-- creating tables (same as consolidated in this example)
message '>>Creating remote tables.' type info to client
go

CREATE TABLE emp (
	emp_id int primary key ,
	emp_name varchar( 128 )
	)
go

create table passthrough_Sql (
	sql_id int primary key,
	sql_stmt varchar(1024),
	stmt_status char(1) default null
)

message '>>Creating publication and subscription' type info to client
go
CREATE PUBLICATION pub1 (
	TABLE emp,
	TABLE passthrough_sql(sql_id, sql_stmt)
)
go

CREATE SYNCHRONIZATION USER ml_user
go

CREATE SYNCHRONIZATION SUBSCRIPTION 
TO pub1
for ml_user
OPTION sv='ver1.0'
go

message '>>Creating hook procedure sp_hook_dbmlsync_schema_upgrade' type info to client
go 

CREATE PROCEDURE sp_hook_dbmlsync_schema_upgrade()
BEGIN
 -- Upgrade the schema based on the data in the passthrough_sql table
  // Declare a cursor to find the SQL to apply
  DECLARE sql_stmt CURSOR FOR
      SELECT sql_id, sql_stmt
      FROM passthrough_sql where stmt_status is null;
  DECLARE sqlid CHAR(1024);
  DECLARE sqlstmt CHAR(1024);
  OPEN sql_stmt;
  FETCH NEXT sql_stmt INTO sqlid, sqlstmt;
  IF sqlstmt is not null then
    // Execute the resulti
    EXECUTE IMMEDIATE sqlstmt;
    // Set the status of the SQL to "C" for completed
    EXECUTE IMMEDIATE 'update passthrough_sql set stmt_status = ''C'' where sql_id = ' || sqlid;
  END IF
END
go
